
#ifndef _card_message_handle_h_
#define _card_message_handle_h_

//一张卡一个ct的所有不同天线的信息

#include <thread>

struct card_location_base;
struct one_ct_message_handle;
struct message_locinfo;
struct task;
template<typename NT> struct zloop;

struct card_message_handle
{
	card_location_base*m_card;
	std::array<one_ct_message_handle*,16> m_ct_list;

	card_message_handle(card_location_base*card);
	~card_message_handle();

#ifndef _RELEASE_
	bool m_first_call=true;
	std::thread::id m_first_call_thread;
#endif 
	
	void on_message(zloop<task*> * loop,const message_locinfo&loc,bool is_history);
};

#endif


